#include <afxwin.h>
#include "CSnooper.h"

#define DEBUG_SNOOPER false

CSnooper::CSnooper() {
  captured = false;
  targetWindow = targetTab = NULL;
}

CSnooper::~CSnooper() {
  signalList.FreeList();
  noiseList.FreeList();
  macList.FreeList();
  apnameList.FreeList();
  channelList.FreeList();
}

bool CSnooper::Capture() {

	CString temp;

	targetWindow = CWnd::FindWindow(NULL,"hp wireless networking Client Manager - Site Monitor");
	if(targetWindow==NULL) {
		return false;
	} 

	// now loop to find the tab window
	
	int i;
	for(i=0;i<0x3FFFFFFF;i+=2) { // find ALL possible windows
		targetTab = targetWindow->GetDescendantWindow(i,FALSE);
		if(targetTab==NULL) continue;
		else {
			// an actual window was returned
			targetTab->GetWindowText(temp);
			if(temp.Compare("Site Monitor")==0) break;
			else targetTab = NULL;
		}
	} 

	if(targetTab==NULL) {
		return false;
	} 

	return true;
}

CWirelessSample * CSnooper::Sample() {

	SnoopedSignal * sig = NULL;
	SnoopedNoise * noi = NULL;
	SnoopedMAC * mac = NULL;
	SnoopedAPName * ap = NULL;
	SnoopedChannel * chan = NULL;

	if(!Capture()) {
		return new CWirelessSample((CWirelessAPNode *) NULL);
	}

	CWnd * tempWindow = NULL;
	
	CString tempString;
	
	CString debugString;
	char buff[24];

	CRect bigWindowRect;
	targetTab->GetWindowRect(bigWindowRect);

	CPoint cp_signal;
	CPoint cp_noise;
	CPoint cp_apname;
	CPoint cp_mac;
	CPoint cp_channel;
    
	if(DEBUG_SNOOPER) debugString = "Geometry is:\nY coordinates: ";

	// was + 92
	cp_signal.y = cp_noise.y = cp_apname.y = cp_mac.y = cp_channel.y = bigWindowRect.top + 5;

	if(DEBUG_SNOOPER) {
		itoa(cp_signal.y,buff,10);
		debugString+=buff;
		debugString+="\ncp_signal.x = ";
	}

	cp_signal.x = bigWindowRect.left + 5;
	
	if(DEBUG_SNOOPER) {
		itoa(cp_signal.x,buff,10);
		debugString+=buff;
		debugString+="\ncp_noise.x = ";
	}
	cp_noise.x = bigWindowRect.left + 95;
		
	if(DEBUG_SNOOPER) {
		itoa(cp_noise.x,buff,10);
		debugString+=buff;
		debugString+="\ncp_apname.x = ";
	}

	cp_apname.x = bigWindowRect.left + 185;
		
	if(DEBUG_SNOOPER) {
		itoa(cp_apname.x,buff,10);
		debugString+=buff;
		debugString+="\ncp_mac.x = ";
	}

	cp_mac.x = bigWindowRect.left + 395;
		
	if(DEBUG_SNOOPER) {
		itoa(cp_mac.x,buff,10);
		debugString+=buff;
		debugString+="\ncp_channel.x = ";
	}

	cp_channel.x = bigWindowRect.left + 495;
	
	if(DEBUG_SNOOPER) {
		itoa(cp_channel.x,buff,10);
		debugString+=buff;
		debugString+="\n\ntargetTab = 0x";
		itoa((int) targetTab->m_hWnd,buff,16);
		debugString+=buff;
		AfxMessageBox(debugString);
	}

	sampleList.FreeList();
	signalList.FreeList();
	noiseList.FreeList();
	macList.FreeList();
	apnameList.FreeList();
	channelList.FreeList();


	// begin the iteration
	//for(int i=(int)targetTab->m_hWnd;i<((int)targetTab->m_hWnd)+0x00001000;i+=2) {
	//for(int i= 0; i<((int) targetTab->m_hWnd) + 0x00001000;i+=2) {
	for(int i=0;i<0x00001000;i+=2) {
		CRect tempRect;
		
		if(IsChild(targetTab->m_hWnd,(HWND) i)==0) {
			continue;
		} 

		if(DEBUG_SNOOPER) debugString = "Found a child.\n";
 
		tempWindow = new CWnd();
		if(tempWindow->Attach((HWND) i)==0) {
			AfxMessageBox("Child found, but unable to attach to it!");
			delete tempWindow;
			continue;
		}

		if(DEBUG_SNOOPER) {
			debugString += "Attached to child: 0x";
			itoa(i,buff,16);
			debugString+= buff;
			debugString+="\n";
		}

/*		// ***
		if(is2017C) {
			AfxMessageBox("Is a Child");
		} */

		// an actual child window was returned

		// only consider VISIBLE children
		// that tricky wabbit just makes its kids
		// invisible when they're unusued, it doesn't
		// actually delete them

		if(tempWindow->IsWindowVisible()==FALSE) {
			tempWindow->Detach();
			delete tempWindow;
			if(DEBUG_SNOOPER) {
				debugString+="Child not visible.";
				AfxMessageBox(debugString);
			}
			continue;
		}
		
		// looking for CStatic's that have the same
		// x-coordinate as one of the CCombo's but
		// have different y-coordinates
		tempWindow->GetWindowRect(tempRect);

		if(DEBUG_SNOOPER) {
			debugString+="Child geometry: x=";
			itoa(tempRect.left,buff,10);
			debugString+=buff;
			debugString+=" y=";
			itoa(tempRect.top,buff,10);
			debugString+=buff;
			debugString+="\n";
		}

		// check for x-match condition
		if(tempRect.left != cp_signal.x &&
		   tempRect.left != cp_noise.x  &&
		   tempRect.left != cp_apname.x &&
		   tempRect.left != cp_mac.x    &&
		   tempRect.left != cp_channel.x ) { 
			tempWindow->Detach(); 
			delete tempWindow;
			
			// ***
//			AfxMessageBox("No x-match");
			if(DEBUG_SNOOPER) {
				debugString+="No x-match";
				AfxMessageBox(debugString);
			}
			continue;
		}

		// check for y-match condition--
		// disclude those that match y's because
		// we don't want the CComboBoxes themselves
		if(tempRect.top == cp_signal.y) {
			tempWindow->Detach();
			// ***
//			AfxMessageBox("Y-match on top");
			delete tempWindow;
			if(DEBUG_SNOOPER) {
				debugString+="Y-match condition (found a combo box)";
				AfxMessageBox(debugString);
			}
			continue;

		}

		// the remaining windows are CStatics
		CStatic * tempStatic = (CStatic *) tempWindow;
		tempStatic->GetWindowText(tempString);

		if(DEBUG_SNOOPER) {
			debugString+="Child text is: >";
			debugString+=tempString;
			debugString+="<\n";
		}

		// if no useful data
		if(tempString=="") {
			tempWindow->Detach();

			// ***
//			AfxMessageBox("Empty");
			if(DEBUG_SNOOPER) {
				debugString+="Child contained no data.";
				AfxMessageBox(debugString);
			}
			delete tempWindow;
			continue;
		}
		if(tempRect.left==cp_signal.x) {
			sig = new SnoopedSignal();
			sig->y = tempRect.top;
			sig->data = atoi( tempString );
//			AfxMessageBox("Signal: "+tempString);
			signalList.AddToEnd(sig);
			
			if(DEBUG_SNOOPER) {
				debugString+="Child was a signal strength.";
				AfxMessageBox(debugString);
			}
			
		} else if(tempRect.left==cp_noise.x) {
			noi = new SnoopedNoise();
			noi->y = tempRect.top;
			noi->data = atoi(tempString );
//			AfxMessageBox("Noise: "+tempString);
			noiseList.AddToEnd(noi);
						
			if(DEBUG_SNOOPER) {
				debugString+="Child was a noise.";
				AfxMessageBox(debugString);
			}
			
		} else if(tempRect.left==cp_apname.x) {
			ap = new SnoopedAPName();
			ap->y = tempRect.top;
			ap->data = tempString;
//			AfxMessageBox("AP Name: "+ap->data);
			// ***
//			AfxMessageBox("FOUND AN AP");
			apnameList.AddToEnd(ap);
						
			if(DEBUG_SNOOPER) {
				debugString+="Child was an AP Name.";
				AfxMessageBox(debugString);
			}
			
		} else if(tempRect.left==cp_mac.x) {
			mac = new SnoopedMAC();
			mac->y = tempRect.top;
			mac->data = tempString;
//			AfxMessageBox("MAC: "+mac->data);
			macList.AddToEnd(mac);
						
			if(DEBUG_SNOOPER) {
				debugString+="Child was a MAC.";
				AfxMessageBox(debugString);
			}
			
		} else if(tempRect.left==cp_channel.x) {
			chan = new SnoopedChannel();
			chan->y = tempRect.top;
			chan->data = atoi(tempString);
//			AfxMessageBox("Channel: "+tempString);
			channelList.AddToEnd(chan);
						
			if(DEBUG_SNOOPER) {
				debugString+="Child was a channel.";
				AfxMessageBox(debugString);
			}

		} else {
			// ***
//			AfxMessageBox("Coordinate mismatch");
		}
	

		tempWindow->Detach();
		delete tempWindow;
		
	}

	tempWindow = NULL;

	// now the lists have appropriate sample data in them
	CWirelessAPNode * apnode = NULL;
	int y;

	apnameList.Reset();
	while(!apnameList.AtEnd()) {
      // find correponding snooped objects;
	  ap = apnameList.Current();
	  y = ap->y;

	  signalList.Reset();
	  noiseList.Reset();
	  channelList.Reset();
	  macList.Reset();

	  while(!signalList.AtEnd()) {
		sig = signalList.Current();
		if(sig->y == y) break;
        signalList.Next();
	  }

	  while(!noiseList.AtEnd()) {
        noi = noiseList.Current();
		if(noi->y == y) break;
		noiseList.Next();
	  }

	  while(!channelList.AtEnd()) {
        chan = channelList.Current();
		if(chan->y == y) break;
		channelList.Next();
	  }

	  while(!macList.AtEnd()) {
        mac = macList.Current();
		if(mac->y == y) break;
		macList.Next();
	  }

	  // now have sig, noi, mac, and chan

	  apnode = new CWirelessAPNode(ap->data.GetBuffer(32),
								   mac->data.GetBuffer(32),
								   sig->data,
								   noi->data,
								   chan->data,
								   apnode);
	  ap->data.ReleaseBuffer();
	  mac->data.ReleaseBuffer();
      apnameList.Next();
	}

	return new CWirelessSample(apnode);

}