#include <afxwin.h>
#include <winsock.h>
#include "CRFMap.h"
#include "CSnooper.h"
#include "modes.h"
#include "list_T.h"

#ifndef __RFWINDOW__
#define __RFWINDOW__

#define TITLE_STRING "CS/RADAR 1.10.d"

class RFWindow : public CFrameWnd {
public:
	RFWindow();
	~RFWindow();

	// sys msg handlers
	afx_msg void OnPaint();
	afx_msg void OnDestroy();

	// file menu msg handlers
	afx_msg void OnQuit();
	afx_msg void OnNewRFMap();
	afx_msg void OnLoad();
	afx_msg void OnSave();
	afx_msg void OnSaveAs();

	// mode menu msg handlers
	afx_msg void OnModeServerLocate();
	afx_msg void OnModeLocalMap();
	afx_msg void OnModeLocalLocate();
	afx_msg void OnModeLocalHybrid();

	// run menu msg handlers
	afx_msg void OnRunContinuous();
	afx_msg void OnRunOneShot();
	afx_msg void OnRunStopRunning();

	// record menu msg handler
	afx_msg void OnRecord();

	// help menu msg handlers
	afx_msg void OnHelpMe();

	// mouse message handlers
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);

	// keypress handler
	afx_msg void OnChar( UINT nChar, UINT nRepCnt, UINT nFlags );



	CWirelessSample * GetAveragedSample();
	void moveLocation(int new_x, int new_y);
	void dumpSample(CWirelessSample * sample);

	void record();

	CBitmap bmp_map;
	CBitmap bmp_x;
	CBitmap bmp_megerian;
	CDC memDC;
	CDC xDC;
	CDC megerianDC;

	bool RF_in_memory;
	bool dump_sample;
	int mode_setting;
	int run_setting;

	// run condition variables
	int nSamples;
	int nTimeBetweenSamples;
	int nTimeBetweenRuns;
	int getpos_mode;

	// server information
	
	int timeout;

	// network vars
    int sock;                        /* Socket descriptor */
    struct sockaddr_in echoServAddr; /* Echo server address */
    struct sockaddr_in fromAddr;     /* Source address of echo */
    unsigned short port;     /* Echo server port */
    unsigned int fromSize;           /* In-out of address size for recvfrom() */
    DWORD servIP;                    /* IP address of server */
//    char *echoString;                /* String to send to echo server */
  //  char echoBuffer[255];        /* Buffer for echo string */
 //   int echoStringLen;               /* Length of string to echo */
    int respStringLen;               /* Length of response string */
    WSADATA wsaData;                 /* Structure for WinSock setup communication */


	// RF Map Itself
	CRFMap * rfmap;
	CString currentFileName;

	// record information
	FILE * recordFile;

	// The data snooper
	CSnooper * snooper;

	// the point at which YOU ARE
	CPoint myLocation;
	CPoint oldLocation;
	bool draw_location;

	// additions for point mapping
	int x[1024];
	int y[1024];

	// for distance
	int xpos; 
	int ypos;

	DECLARE_MESSAGE_MAP()
};

#endif

