#include <afxwin.h>
#include <afxsock.h>

#ifndef __RFSERVERWINDOW__
#define __RFSERVERWINDOW__

#include "CRFMap.h"
#include "RFWindow.h"

#define LINES 44		// Max # of lines
#define LINE_LENGTH 57 // Max # of characters per line
#define LINE_HEIGHT 16  // # pixels between each line

class RFServerWindow : public CFrameWnd {
public:
	RFServerWindow();
	~RFServerWindow();

	// sys msg handlers
	afx_msg void OnPaint();
	afx_msg void OnChar(UINT uChar, UINT uRepCnt, UINT uFlg);
	afx_msg void OnDestroy();

	void PrintMessage(const char * message);
	void parse(char * theline);
	int doTokenComparisons(char * token);
	void IgnoreOtherTokens();

	char m_asText[LINES][LINE_LENGTH]; // text
	int m_anLen[LINES];				  // keep track of line lengths
	int m_nLine;					  // line receiving keystrokes

	bool msg_printed;

	int getpos_mode;


	CRFMap * rfmap;
	CString fileName;
	bool fileOpen;

	bool verbose;

	bool server_running;

	int sock;                        /* Socket */
    struct sockaddr_in echoServAddr; /* Local address */
    struct sockaddr_in echoClntAddr; /* Client address */
    char echoBuffer[255];        /* Buffer for echo string */
    unsigned short port;             /* Server port */
    int cliLen;                      /* Length of incoming message */
    int recvMsgSize;                 /* Size of received message */
    WSADATA wsaData;                 /* Structure for WinSock setup communication */

	RFWindow * rfwnd;

	DECLARE_MESSAGE_MAP()
};

#endif

