#include "RFWindow.h"

RFWindow::RFWindow() {
	if(Create(NULL,TITLE_STRING,WS_OVERLAPPEDWINDOW,
		CRect(0,0,521,744),NULL)==FALSE) {

		AfxMessageBox("Failed to create window");
		exit(-1);
	}
	
	if(bmp_map.LoadBitmap("map")==0) {
		AfxMessageBox("Failed to load map bitmap");
		exit(-1);
	}
	CClientDC dc(this);
	if(memDC.CreateCompatibleDC(&dc)==0) {
		AfxMessageBox("Failed to create compatible device context");
		exit(-1);
	}
	memDC.SelectObject(&bmp_map);
	
	if(bmp_x.LoadBitmap("redx")==0) {
		AfxMessageBox("Failed to load map bitmap");
		exit(-1);
	}
	if(xDC.CreateCompatibleDC(&dc)==0) {
		AfxMessageBox("Failed to create compatible device context");
		exit(-1);
	}
	xDC.SelectObject(&bmp_x);

	if(bmp_megerian.LoadBitmap("megerian")==0) {
		AfxMessageBox("Failed to load Megerian's picture");
		exit(-1);
	}
	if(megerianDC.CreateCompatibleDC(&dc)==0) {
		AfxMessageBox("Failed to create compatible device context");
		exit(-1);
	}
	megerianDC.SelectObject(&bmp_megerian);

	draw_location = false;

//	x[0] = -1; y[0] = -1;
}

RFWindow::~RFWindow() {
	
}

afx_msg void RFWindow::OnPaint() {
	CPaintDC dc(this);

	// draw the map itself
	dc.BitBlt( 0,0,521,696,&memDC,0,0,SRCCOPY);

	if(draw_location) {
		dc.BitBlt( myLocation.x-3,myLocation.y-2,5,6,&xDC,0,0,SRCCOPY);

		if( myLocation.x > 149 && myLocation.x < 194 &&
			myLocation.y > 250 && myLocation.y < 343) { // near megerian's office
			dc.BitBlt(10,10,150,200,&megerianDC,0,0,SRCCOPY);
			dc.TextOut(10,210,"\"Our fearless leader\"");
		}
	}

}  

void RFWindow::moveLocation(int new_x, int new_y) {

	myLocation.x = new_x;
	myLocation.y = new_y;
	draw_location= true;
	Invalidate(TRUE);

}

afx_msg void RFWindow::OnDestroy() {
	RFWindow::window_up = false;
}

BEGIN_MESSAGE_MAP( RFWindow, CFrameWnd )

  ON_WM_DESTROY()
  ON_WM_PAINT()
 
END_MESSAGE_MAP()

