
long horspool(char * text, int text_length, char * pattern, int pattern_length) {
  pattern_length--; // account for null termination
  long compares = 0;
  int * table = new int[256]; // use ASCII for indexing

  // initialize table to shift of full pattern
  for(int i=0;i<256;i++) table[i]=pattern_length;

  // do preprocessing
  for(int i=0; i<pattern_length-2;i++) {
    table[pattern[i]] = pattern_length - i - 1;
  }

  int right_end = pattern_length - 1;;
  int num_matched_chars;

  while(right_end < text_length) {

    num_matched_chars = 0;

    while(pattern[pattern_length-1-num_matched_chars]==text[right_end-num_matched_chars] &&
          num_matched_chars < pattern_length ) {
      compares++;
      num_matched_chars++;

    }

    compares++; // once for failed comparison

    if(num_matched_chars==pattern_length) {
      // a match has been found
 //     printf("MATCH FOUND AT BYTE %i\n",right_end-pattern_length+2);
      return compares;
    } else {
      // not a match, move on
      right_end += table[text[right_end]];
    }

  }

// printf("NO MATCH\n");
  return -1;

}

