#include <afxwin.h>

#ifndef __RFWINDOW__
#define __RFWINDOW__

#define TITLE_STRING "CS/RADAR Results Viewer v1.2"

class RFWindow : public CFrameWnd {
public:
	RFWindow();
	~RFWindow();

	// sys msg handlers
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnMButtonDown( UINT nFlags, CPoint point );

	// keypress handler
	afx_msg void OnChar( UINT nChar, UINT nRepCnt, UINT nFlags );

	void Load();
	void LoadSamples(char * filename);
	void Save();

	bool AddSample(CPoint point);
	bool UndoAdd();

	CBitmap bmp_map;
	CBitmap bmp_x;
	CDC memDC;
	CDC xDC;

	CString currentFileName;

	// record information
	FILE * infile;

	int truex[1024];
	int truey[1024];

	int predx[1024];
	int predy[1024];

	int sampx[1024];
	int sampy[1024];
	int next_sample;

	bool draw_numbers;
	bool draw_background;
	bool draw_truepath;
	bool draw_predpath;
	bool draw_elipses;
	bool draw_samples;

	DECLARE_MESSAGE_MAP()
};

#endif

